#pragma once


#define WND_SMSRECV_LIST_BG_COLOR						Color(255, 255, 255, 255)
#define WND_SMSRECV_LIST_BORDER_COLOR					Color(255, 201, 201, 201)
#define WND_SMSRECV_LIST_ITEM_BG_COLOR					Color(255, 229, 243, 255)
#define WND_SMSRECV_LIST_ITEM_BORDER_COLOR				Color(255, 203, 230, 255)
#define WND_SMSRECV_LIST_ITEM_HIGHLIGHT_COLOR			Color(255, 191, 224, 255)
#define WND_SMSRECV_LIST_ITEM_HIGHLIGHT_BORDER_COLOR	Color(255, 151, 199, 242)

#define WND_SMSRECV_LIST_FONT_COLOR						Color(255, 0, 0, 0)

#define WND_SMSRECV_LIST_ITEM_HEIGHT							(20)
#define WND_SMSRECV_LIST_ITEM_Y_GAP								(5)
#define WND_SMSRECV_LIST_ITEM_POSITION_X						(24)
#define WND_SMSRECV_LIST_ITME_START_Y							(5)
#define WND_SMSRECV_LIST_ITEM_POSITION_WIDTH					(185)
//#define DEF_USERMGR_ITEM_FONT_NAME				(L"")
#define DEF_USERMGR_ITEM_FONT_HEIGHT			(9)
#define DEF_USERMGR_ITEM_FONT_STYLE				(FontStyleRegular)

#define ID_RECV_SCROLLBAR					0x7332

typedef enum _scroll_type
{
	SCROLL_UP = 0,
	SCROLL_DOWN,
	SCROLL_PAGEUP,
	SCROLL_PAGEDOWN
} ESCROLL_TYPE;


class CWndSMSRecvList : public CWnd
{
	DECLARE_DYNAMIC(CWndSMSRecvList)

public:
	CWndSMSRecvList();
	virtual ~CWndSMSRecvList();
	typedef struct user_item_info
	{
		int						nIndex;
		CString					strName;
		CString					strID;
		CString					strTelNum;
		CRect					rtItem;
		CRect					rtName;
		CRect					rcTelNum;
		CSize					szName;
		CRect					rtDelete;
		BOOL					bHoverDelete;
		BOOL					bDown;
		BOOL					bDownDelete;

		user_item_info()
		{
            nIndex = 0;
			strName = _T("");
			strID = _T("");
			strTelNum = _T("");

			rtItem.SetRectEmpty();
			rtName.SetRectEmpty();
			rtDelete.SetRectEmpty();

			bHoverDelete = FALSE;
			bDown = FALSE;
			bDownDelete = FALSE;
		}
	} USER_ITEM_INFO, *PUSER_ITEM_INFO;

	void						SetImgBGPath(CString strFileName);
	void						SetImgDeletePath(CString strFileName, CString strFileNameOver);
	void						SetFontConfig(WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText);
	void						ClearUserMgrItemAll();
	USER_ITEM_INFO*				AllocUserMgrItem(CString strName, CString strID, CString strTelNum);
	void						AddUserMgrItem(CString strID, CString strName, CString strTelNum);
	void						DeleteUserMgrItem(USER_ITEM_INFO* pUMInfoDel);
	void						UpdateWndInfo(USER_ITEM_INFO* pUMInfo);


protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaint();
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnMouseLeave();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg LRESULT OnAddUser(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnAddFail(WPARAM wParam, LPARAM lParam);

private:
	CPtrArray					m_ptrArrayItem;
	Image*						m_pImgDelete;
	Image*						m_pImgDeleteOver;

	WCHAR						m_wszFontName[64];
	REAL						m_nFontHeight;
	FontStyle					m_fontStyle;


	Color						m_crBG;
	Color						m_crBGOutline;
	Color						m_crItemBG;
	Color						m_crItemOutline;
	Color						m_crItemBGHighlight;
	Color						m_crItemOutlineHighlight;
	Color						m_crText;
	
	int				m_nScrollOneSize;
	int				m_nScrollPageSize;
	BOOL			m_bScrollEndReached;

public:
	afx_msg void OnSize(UINT nType, int cx, int cy);
	void SortUserItemList();
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	void DoScroll(long lScrollValue );
	BOOL ScrollItem(int nDiff);
	void UpdateScrollInfo();
	CScrollBar				m_wndScrollBar;
};


